"use strict";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const fetch = require("node-fetch");

const crypto = require("crypto");

const queryString = require("query-string");

exports.sourceNodes =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(function* ({
    actions
  }, {
    authToken,
    before,
    after
  }) {
    if (!authToken) {
      throw new Error("You must provide an `authToken` to `gatsby-source-strava-activities`.");
    }

    const {
      createNode
    } = actions;
    const activities = [];
    let numResults = null;
    let page = 1;

    do {
      const params = queryString.stringify({
        after,
        before,
        page,
        per_page: 30
      }); // eslint-disable-next-line no-await-in-loop

      const res = yield fetch(`https://www.strava.com/api/v3/athlete/activities?${params}`, {
        headers: {
          Authorization: `Bearer ${authToken}`
        }
      }); // eslint-disable-next-line no-await-in-loop

      const data = yield res.json();
      numResults = data.length;
      page += 1;
      data.forEach(d => {
        activities.push(d);
      });
    } while (numResults > 0);

    activities.forEach(activity => {
      const jsonString = JSON.stringify(activity);
      const gatsbyNode = {
        activity: Object.assign({}, activity),
        id: `Strava Activity: ${activity.id}`,
        parent: "__SOURCE__",
        children: [],
        internal: {
          type: "StravaActivity",
          contentDigest: crypto.createHash("md5").update(jsonString).digest("hex")
        }
      };
      createNode(gatsbyNode);
    });
  });

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();